Subject: Re: [PATCH net-next] rtnetlink: Allow setting IFLA_PERM_ADDRESS at device creation time

From: Jakub Kicinski <[email-masked]>
Date: Tue, 18 Feb 2025 06:37:10 -0800

On Tue, 18 Feb 2025 13:51:42 +0100 Toke Høiland-Jørgensen wrote:
> >> Hmm, and you don't see any value in being able to specify a permanent
> >> identifier for virtual devices? That bit was not just motivated
> >> reasoning on my part... :)  
> >
> > I can't think of any :( Specifying an address is already possible.  
> 
> Right, but the address can be changed later. Setting the perm_addr makes
> it possible for a management daemon to set a unique identifier at device
> creation time which is guaranteed to persist through any renames and
> address changes that other utilities may perform. That seems like a
> useful robustness feature that comes at a relatively low cost (the patch
> is fairly small and uncomplicated)?
> 
> > Permanent address is a property of the hardware platform.
> > Virtual devices OTOH are primarily used by containers, 
> > which are ephemeral by design. At least that's my mental model.  
> 
> Sure, any device feature that comes from hardware is only going to fit
> virtual devices by analogy. But I don't think the analogy here is super
> far fetched (cf the above)? :)

I'm not sure how to answer this. It all sounds really speculative
and disconnected with how I see virtual devices being used.